package impl

import (
	"context"

	"github.com/zeebe-io/zeebe/clients/go/pkg/entities"
	"github.com/zeebe-io/zeebe/clients/go/pkg/zbc"
	"gitlab.okta-solutions.com/mashroom/backend/common/generic/bpms"
	invitation "gitlab.okta-solutions.com/mashroom/backend/invitation/api"
)

func (server *serverImpl) ServeBpms() (zbc.Client, error) {
	return bpms.ServeBpms("invitation-service", bpms.MapHandler(map[string]bpms.Registrator{
		"invite-user": func() (request interface{}, processor bpms.Processor) {
			req := &invitation.InvitationResolution{}
			return req, func(ctx context.Context, job entities.Job) (reply interface{}, enhance map[string]interface{}, err error) {
				req.Process = job.GetWorkflowInstanceKey()
				resp, err := server.CreateInvitation(ctx, req)
				if err != nil {
					return nil, nil, err
				}
				return map[string]interface{}{
					"invitation_id": resp.GetInfo().GetId(),
				}, nil, nil
			}
		},
	}))
}
